<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Document</title>
    <style>
     body {
         padding: 16px;
     }

     button[is="mi-boton-Extendido"] {
         padding: 10px;
         font-weight: bold;
     }
    </style>
</head>
<body>
        <button is="mi-boton-extendido">Soy un Boton</button>

        <div id="container">

        </div>
    <script>
        class MibotonExtendido extends HTMLButtonElement{
            constructor(){
                super();
                this.addEventListener('click', (e) => {
                    console.log("evento click: " + this.innerHTML);
                    alert('MibotonExtendido');
                });
            }

            static get ceName () {
                return 'mi-boton-extendido';
            }

            get is() {
                return this.getAttribute('is');
            }

            set is(value) {
                this.setAttribute('is', value || this.ceName);
            }
        }

        customElements.define('mi-boton-extendido',MibotonExtendido, {extends: 'button'});

        const mibotonExtendido2 = document.createElement('button',{is: MibotonExtendido.ceName});

        mibotonExtendido2.textContent = "soy un mi-boton-extendido";
        document.body.appendChild(mibotonExtendido2);

        const mibotonExtendido3 = document.createElement('button',{is: MibotonExtendido.ceName});
        mibotonExtendido3.textContent = "hola-btn3";
        document.querySelector("#container").appendChild(mibotonExtendido3);

        </script>
</body>
</html>